VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   5805
   ClientLeft      =   120
   ClientTop       =   450
   ClientWidth     =   5730
   LinkTopic       =   "Form1"
   ScaleHeight     =   5805
   ScaleWidth      =   5730
   StartUpPosition =   3  'Windows Default
   Begin VB.PictureBox pbGame 
      Appearance      =   0  'Flat
      AutoRedraw      =   -1  'True
      BackColor       =   &H80000005&
      ForeColor       =   &H80000008&
      Height          =   4575
      Left            =   120
      ScaleHeight     =   4545
      ScaleWidth      =   5385
      TabIndex        =   0
      Top             =   120
      Width           =   5415
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Type pointAPI
    x  As Long
    y  As Long
End Type
Private Declare Function GetCursorPos Lib "user32" (lpPoint As pointAPI) As Long
Private Declare Function ScreenToClient Lib "user32" (ByVal hWnd As Long, lpPoint As pointAPI) As Long
Private game As colCells

Private Sub Form_Load()
   pbGame.Move 0, 0
   Set game = New colCells
   game.Init 4, 4
   game.Shuffle 20
End Sub

Private Sub Form_Resize()
   If Me.WindowState = vbMinimized Then Exit Sub
   Dim w As Long, h As Long
   w = Int(ScaleWidth / game.Columns)
   h = Int(ScaleHeight / game.Rows)
   If w > h Then w = h
   game.CellSize = w
   RedrawPicture
End Sub

Private Sub pbGame_Click()
   Dim pt As pointAPI
   GetCursorPos pt
   ScreenToClient pbGame.hWnd, pt
   Dim clickedCell As gameCell, newCell As gameCell
   Set clickedCell = game.ItemByPos(pt.x * Screen.TwipsPerPixelX, pt.y * Screen.TwipsPerPixelY)
   Set newCell = game.CellToMove(clickedCell)
   If Not newCell Is Nothing Then
      SwapCells clickedCell, newCell
      If game.IsCorrect Then MsgBox "Done!"
   End If
End Sub

Private Sub pbGame_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
   Dim gc As gameCell
   Set gc = game.ItemByPos(x, y)
   Dim md As MoveDirection
   md = game.CanMove(gc)
   Select Case md
      Case MoveDirection.MoveNone
           pbGame.MousePointer = vbNoDrop
      Case MoveDirection.MoveDown
           pbGame.MousePointer = vbCustom
           pbGame.MouseIcon = LoadResPicture("ARRDOWN", 1)
      Case MoveDirection.MoveUp
           pbGame.MousePointer = vbCustom
           pbGame.MouseIcon = LoadResPicture("ARRUP", 1)
      Case MoveDirection.MoveLeft
           pbGame.MousePointer = vbCustom
           pbGame.MouseIcon = LoadResPicture("ARRLEFT", 1)
      Case MoveDirection.MoveRight
           pbGame.MousePointer = vbCustom
           pbGame.MouseIcon = LoadResPicture("ARRRIGHT", 1)
      Case Else
          pbGame.MousePointer = vbDefault
   End Select
End Sub

Private Sub RedrawPicture()
   With pbGame
      .Cls
      .Width = game.CellSize * game.Columns
      .Height = game.CellSize * game.Rows
      .AutoRedraw = True
      .FontSize = 24
   End With
   Dim i As Long
   For i = 1 To 3
       pbGame.Line (0, game.CellSize * i)-(pbGame.Width, game.CellSize * i)
       pbGame.Line (game.CellSize * i, 0)-(game.CellSize * i, pbGame.Height)
   Next i
   Dim gc As gameCell
   For Each gc In game
       If gc.index <> 0 Then PrintCell gc
   Next
End Sub

Private Sub SwapCells(cell_clicked As gameCell, cell_empty As gameCell)
   With pbGame
        ClearCell cell_clicked
        cell_empty.index = cell_clicked.index
        cell_clicked.index = 0
        PrintCell cell_empty
   End With
End Sub
Private Sub ClearCell(c As gameCell)
   Dim x As Long
   x = game.CellSize - 32
   pbGame.Line (c.left + 16, c.top + 16)-(c.left + x, c.top + x), pbGame.BackColor, BF
End Sub
Private Sub PrintCell(c As gameCell)
   Dim s As String
   s = c.index
   pbGame.CurrentX = c.left + (game.CellSize - pbGame.TextWidth(s)) / 2
   pbGame.CurrentY = c.top + (game.CellSize - pbGame.TextHeight(s)) / 2
   pbGame.Print s
End Sub

