VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "colCells"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"No"
Attribute VB_Ext_KEY = "Collection" ,"gameCell"
Attribute VB_Ext_KEY = "Member0" ,"gameCell"
Option Explicit

Public Enum MoveDirection
   MoveNone
   MoveUp
   MoveDown
   MoveLeft
   MoveRight
End Enum

Private mCol As Collection
Private m_rows As Long, m_cols As Long, m_cellSize As Long

Public Sub Init(Optional GameColumns As Long = 4, _
                Optional GameRows As Long = 4, Optional cSize As Long = 1200)
   m_rows = GameRows: m_cols = GameColumns
   m_cellSize = cSize
   Dim i As Long, j As Long
   Dim gc As gameCell
   For i = 1 To m_rows
       For j = 1 To m_cols
           Set gc = New gameCell
           With gc
              .index = (i - 1) * m_cols + j - 1
              .staticIndex = .index
              .row = i: .col = j
              .left = (.col - 1) * m_cellSize
              .top = (.row - 1) * m_cellSize
              mCol.Add gc, CStr(.staticIndex)
           End With
       Next j
   Next i
End Sub

Public Sub Shuffle(ByVal nRounds As Long)
   Dim i As Integer
   Dim emptyCell As gameCell
   Dim newCell As gameCell
   Set emptyCell = EmptyItem
   Dim colDirs As Collection
   Dim lastMove As MoveDirection
   For i = 1 To nRounds
       Set colDirs = New Collection
       If emptyCell.row > 1 And lastMove <> MoveUp Then colDirs.Add MoveDown
       If emptyCell.row < m_rows And lastMove <> MoveDown Then colDirs.Add MoveUp
       If emptyCell.col > 1 And lastMove <> MoveLeft Then colDirs.Add MoveRight
       If emptyCell.col < m_cols And lastMove <> MoveRight Then colDirs.Add MoveLeft
       Dim md As MoveDirection
       md = colDirs(GetRandom(1, colDirs.Count))
       lastMove = md
       Select Case md
          Case MoveDirection.MoveDown
               Set newCell = Item(CStr(emptyCell.staticIndex - m_cols))
          Case MoveDirection.MoveUp
               Set newCell = Item(CStr(emptyCell.staticIndex + m_cols))
          Case MoveDirection.MoveRight
               Set newCell = Item(CStr(emptyCell.staticIndex - 1))
          Case MoveDirection.MoveLeft
               Set newCell = Item(CStr(emptyCell.staticIndex + 1))
       End Select
       'Debug.Print "=>" & newCell.index;
       emptyCell.index = newCell.index
       newCell.index = 0
       Set emptyCell = newCell
   Next i
End Sub

Public Property Get Rows() As Long
   Rows = m_rows
End Property
Public Property Get Columns()
   Columns = m_cols
End Property

Public Property Let CellSize(value As Long)
   m_cellSize = value
   Dim gc As gameCell
   For Each gc In mCol
      gc.left = (gc.col - 1) * m_cellSize
      gc.top = (gc.row - 1) * m_cellSize
   Next
End Property
Public Property Get CellSize() As Long
   CellSize = m_cellSize
End Property

Public Property Get EmptyItem() As gameCell
   Dim gc As gameCell
   For Each gc In mCol
      If gc.index = 0 Then
         Set EmptyItem = gc
         Exit Property
      End If
   Next
End Property
Public Property Get Item(vntIndexKey As Variant) As gameCell
Attribute Item.VB_UserMemId = 0
    Set Item = mCol(vntIndexKey)
End Property
Public Function ItemByRowCol(row As Long, column As Long) As gameCell
   Dim idx As Long
   idx = (row - 1) * m_cols + column - 1
   Set ItemByRowCol = Item(CStr(idx))
End Function
Public Function ItemByPos(ByVal x As Long, ByVal y As Long) As gameCell
   Dim row As Long, col As Long
   col = Int(x / m_cellSize) + 1
   row = Int(y / m_cellSize) + 1
   Set ItemByPos = ItemByRowCol(row, col)
End Function

Public Function CellToMove(gc As gameCell) As gameCell
   If gc.index = 0 Then Exit Function
   Dim newCell As gameCell
   If gc.col > 1 Then
      Set newCell = Item(CStr(gc.staticIndex - 1))
      If newCell.index = 0 Then
         Set CellToMove = newCell: Exit Function
      End If
   End If
   If gc.col < m_cols Then
      Set newCell = Item(CStr(gc.staticIndex + 1))
      If newCell.index = 0 Then
         Set CellToMove = newCell: Exit Function
      End If
   End If
   If gc.row > 1 Then
      Set newCell = Item(CStr(gc.staticIndex - m_cols))
      If newCell.index = 0 Then
         Set CellToMove = newCell: Exit Function
      End If
   End If
   If gc.row < m_rows Then
      Set newCell = Item(CStr(gc.staticIndex + m_cols))
      If newCell.index = 0 Then
         Set CellToMove = newCell: Exit Function
      End If
   End If
End Function
Public Function CanMove(gc As gameCell) As MoveDirection
   CanMove = MoveNone
   Dim newCell As gameCell
   Set newCell = CellToMove(gc)
   If newCell Is Nothing Then Exit Function
   If newCell.row = gc.row Then
      If newCell.col < gc.col Then
         CanMove = MoveLeft
      Else
         CanMove = MoveRight
      End If
   ElseIf newCell.col = gc.col Then
      If newCell.row < gc.row Then
         CanMove = MoveUp
      Else
         CanMove = MoveDown
      End If
   End If
End Function

Public Property Get Count() As Long
    Count = mCol.Count
End Property

Public Property Get NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    Set NewEnum = mCol.[_NewEnum]
End Property

Public Property Get IsCorrect() As Boolean
   Dim gc As gameCell
   For Each gc In mCol
      If Not gc.IsCorrect Then Exit Property
   Next
   IsCorrect = True
End Property

Private Function Min(x As Long, y As Long) As Long
   If x > y Then Min = y Else Min = x
End Function
Private Function Max(x As Long, y As Long) As Long
   If x < y Then Max = y Else Max = x
End Function
Private Function GetRandom(ByVal minValue As Long, ByVal maxValue As Long) As Long
   GetRandom = Int((maxValue - minValue + 1) * Rnd + minValue)
End Function

Private Sub Class_Initialize()
    Set mCol = New Collection
    Randomize Timer
End Sub
Private Sub Class_Terminate()
    Set mCol = Nothing
End Sub

